<?php

namespace Plugin\DsLockedBlock;

use Ip\Internal\Content\Model;

class Event
{
    public static function ipBeforeController()
    {
        $permission = ipAdminPermission('Super admin');
        ipAddJsVariable('ipSuperAdmin', $permission);

        if (!$permission && ipIsManagementState()) {
            ipAddJsContent('LockedBlockManagement', '
            $(document).ready(function() {
                var style = document.createElement("style");
                style.type = "text/css";
                style.innerHTML = ".ipWidget-LockedBlock .ipsWidgetControls { display: none !important; }";
                document.getElementsByTagName("head")[0].appendChild(style);

                if (typeof ipSuperAdmin != "undefined" && ipSuperAdmin) {
                    var orig = ipContent.createWidget;
                    ipContent.createWidget = function() {
                        console.log(arguments[0].indexOf("lockedBlock"));
                        if (typeof arguments[0] != "undefined" && arguments[0].indexOf("lockedBlock") == 0) return false;
                        orig.apply(null, arguments);
                    };
                }
            });
        ');
        }
    }

    public static function ipBeforeWidgetMove($info)
    {
        $widget = Model::getWidgetRecord($info['widgetId']);
        if ($widget['name'] != 'LockedBlock') {
            return;
        }

        if (empty($widget['data']['blockName'])) {
            $widget['data']['blockName'] = 'lockedBlock' . $widget['id'];
        }

        if ($widget['revisionId'] != $info['revisionId'] || $widget['languageId'] != $info['languageId']) {
            $blockWidgets = Model::getBlockWidgetRecords($widget['data']['blockName'], $widget['revisionId'], $widget['languageId']);
            foreach ($blockWidgets as $key => $innerWidget) {
                Model::moveWidget($innerWidget['id'], $key, $widget['data']['blockName'], $info['revisionId'], $info['languageId']);
            }
        }
    }
}
